#!/bin/sh

LIBTOOLIZE=libtoolize

if [ $(uname) = "Darwin" ]
then
	LIBTOOLIZE=glibtoolize
fi

rm -rf autom4te.cache &&
# update libtool version
V1=$(head -n 1 VERSION | cut -f 1 -d '.') &&
V2=$(head -n 1 VERSION | cut -f 2 -d '.') &&
V3=$(head -n 1 VERSION | cut -f 3 -d '.') &&
echo "LT_VERSION_CURRENT = ${V1}" > config/lt_version.am &&
echo "LT_VERSION_REVISION = ${V3}" >> config/lt_version.am &&
echo "LT_VERSION_AGE = 0" >> config/lt_version.am &&
# run autogen tools
${LIBTOOLIZE} --force \
&& aclocal \
&& autoconf \
&& autoheader \
&& automake --gnu --add-missing
