// logarithmic direct method class definitions
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#if HAVE_CONFIG_H
	#include <config.h>
#endif

#include "LogarithmicDirectMethod.h"

#include <limits>

using namespace Simulation;

// constructor
LogarithmicDirectMethod::LogarithmicDirectMethod(const unsigned long seed) \
		: SimulationAlgorithm("Logarithmic direct method", seed) { }

// initialise algorithm
int LogarithmicDirectMethod::preprocess(void)
{
/*	register unsigned long i;
	register double tautmp;
	Compartment *compartment;

	// calculate tau and mu for each compartment
	// and find compartment with smallest tau
	tau0 = TAUMAX;
	for(i = 0; i < num_compartments; i++) {
		compartment = psystem->getCompartment(i);
		psystem->execute(i);
		tautmp = compartment->getTimeToNextReaction();
		// keep information about compartment with smallest tau
		if(tautmp != 0.0 && tautmp < tau0) {
			tau0 = tautmp;
			i0 = i;
			mu0 = compartment->getNextReaction();
		}
	}*/
}

// perform one iteration of algorithm for all compartments
// using multicompartment logarithmic direct algorithm
int LogarithmicDirectMethod::execute(void)
{
/*	register unsigned long i, i0new = 0, mu0new = 0;
	register double tau0new, tautmp;
	register Compartment *compartment;

	// update simulation time
	advanceTime(tau0);

	// execute reaction
	// reduce time in all other compartments except selected compartment
	tau0new = TAUMAX;
	for(i = 0; i < num_compartments; i++) {
		if(i != i0) {
			compartment = psystem->getCompartment(i);
			if((tautmp = compartment->getTimeToNextReaction()) == 0.0)
				continue;
			compartment->setTimeToNextReaction(tautmp -= tau0);
			// keep compartment with smallest time to next reaction
			if(tautmp != 0.0 && tautmp < tau0new) {
				tau0new = tautmp;
				i0new = i;
				mu0new = compartment->getNextReaction();
			}
		}
	}

	// perform reaction in selected compartment
	compartment = psystem->getCompartment(i0);
	psystem->executeRule(rs0, mu0, i0);

	// run gillespie to recalculate next reaction in selected compartment
	psystem->execute(i0);
	// make next reaction if time to next reaction the smallest
	tautmp = compartment->getTimeToNextReaction();
	if(tautmp != 0.0 && tautmp < tau0new) {
		tau0new = tautmp;
		i0new = i0;
		mu0new = compartment->getNextReaction();
	}

	// update target compartment if channel
	if(compartment->isChannel(rs0, mu0)) {
		i = compartment->calculateRuleTarget(rs0, mu0);
		// run gillespie to recalculate next reaction in target compartment
		psystem->execute(i);
		// make next reaction if time to next reaction the smallest
		compartment = psystem->getCompartment(i);
		tautmp = compartment->getTimeToNextReaction();
		if(tautmp != 0.0 && tautmp < tau0new) {
			tau0new = tautmp;
			i0new = i;
			mu0new = compartment->getNextReaction();
		}
	}

	// finish if no more reactions to execute
	if(tau0new == TAUMAX) {
		tau0 = mu0 = i0 = 0;
		return 0;
	}

	// set next reaction
	tau0 = tau0new;
	i0 = i0new;
	mu0 = mu0new;
*/
	return 1;
}

// perform one iteration of algorithm for one compartment
// using logarithmic direct method
void LogarithmicDirectMethod::execute(unsigned long c)
{
/*	register unsigned long i, mu0, rs0;
	register double a0, tau0, r1, r2, am, *acum;
	register Compartment *compartment;

	// don't run for compartments with no rules
//	if(!compartment->getNumRules())
//		return;

	// calculate propensities
	compartment = psystem->getCompartment(c);
	acum = compartment->getRuleSet()->getCumulativePropensities();
	a0 = 0.0;
	for(rs0 = 0; rs0 < compartment->getNumRuleSets(); rs0++)
		for(i = 0; i < compartment->getNumRules(rs0); i++) {
			a0 += calculatePropensity(rs0, i, c);
			acum[i] = a0;
		}

	// finish if zero level
	if(a0 == 0.0) {
		compartment->setTimeToNextReaction(0.0);
		compartment->setNextReaction(0);
		compartment->setNextRuleSet(0);
		return;
	}

	// generate time to next reaction
	r1 = randomNumber();
	tau0 = -1.0 * log(r1) / a0;

	// select next reaction
	r2 = randomNumber();
	am = r2 * a0;
	long int ih = compartment->getTotalNumRules();
	long int il = -1;
	unsigned long im;
	while((ih - il) > 1) {
		im = ((unsigned long) il + ih) >> 1;
		if(acum[im] < am)
			il = im;
		else
			ih = im;
	}
	mu0 = ih;

	compartment->setTimeToNextReaction(tau0);
	compartment->setNextReaction(mu0);
	compartment->setNextRuleSet(rs0);*/
}
