// logarithmic direct method class definitions
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef LOGARITHMICDIRECTMETHOD_H
#define LOGARITHMICDIRECTMETHOD_H

#include "Psystem.h"

namespace Simulation {

// gillespie direct method
class LogarithmicDirectMethod : public SimulationAlgorithm {
	public:
		// constructor
		LogarithmicDirectMethod(const unsigned long seed = 0);

		// perform one iteration of algorithm for all compartments
		int execute(void);

		// perform one iteration of algorithm for one compartment
		void execute(unsigned long);

		// initialise algorithm
		int preprocess(void);
};

}

#endif
