// distributed mcss and cma-es parameter optimisation
// copyright 2008, 2009, 2010 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef MCSSCMAES_H
#define MCSSCMAES_H

#include <gsl/gsl_rng.h>
#include "mcss/McssCmaesParameters.h"
#include "mcss/SimulationParameters.h"
#include "mcss/SimulationQuery.h"

using namespace Simulation;

namespace Simulation {

// return mcss-cmaes parameters
McssCmaesParameters *cmaesParameters(void);

// return mcss parameters
SimulationParameters *mcssParameters(void);

// read in target data
void readTargetData(void);

// return number of rows in target data
int targetDataRows(void);

// return number of columns in target data
int targetDataColumns(void);

// return array of target data timepoints
double *targetDataTimepoints(void);

// return entry in target data
double targetData(int row, int column);

// return target data array
double **targetData(void);

// run mcss from parameter file
void run_mcss(const char *param_file, const char *params);

};

#endif
