// model properties simulation
// copyright 2008, 2009, 2010 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef MCSSPROPERTIES_H
#define MCSSPROPERTIES_H

#include "mcss/mcss.h"
#include "mcss/McssPropertiesParameters.h"

using namespace Simulation;

namespace Simulation {

typedef struct PropertiesResults {
	// find_value_monotonic results
	double input;  // input concentration
	double input_ss;  // input concentration at steady state
	double output;  // output concentration
	double *outputs;  // output concentrations for individual output species
	unsigned int num_output_species;  // number of output species
	double max_time;  // simulation max_time
	unsigned int iterations;  // number of iterations performed
} PropertiesResults;
	
// find steady state species concentration
void find_value_monotonic(McssPropertiesParameters &properties_parameters, \
		PropertiesResults &properties_results);

};

#endif
