// parameter class definitions
// automatically generated by make-parameter-class
// part of libecsb - the executable cell systems biology library
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef MCSSPROPERTIESPARAMETERS_H
#define MCSSPROPERTIESPARAMETERS_H

#include <ecsb/ecsb.h>

// McssPropertiesParameters class
class McssPropertiesParameters : public ECSB::ParameterSet {
	public:
		// constructor
		McssPropertiesParameters(void);

		// parameters
		// property to calculate
		char property[PARAMETER_STR_MAX];
		// show progress
		bool show_progress;
		// output header with data
		bool output_header;
		// mcss simulation parameters file
		char mcss_parameters[PARAMETER_STR_MAX];
		// interval to test for steady-state
		double steady_state_interval;
		// maximum search iterations to perform
		unsigned int max_iterations;
		// initial lower search bound
		double lower_bound;
		// initial upper search bound
		double upper_bound;
		// dose specie
		std::string input_species;
		// response species
		std::string output_species;
		// target steady-state value
		double target;
		// tolerance within which to calculate steady-state value
		double tolerance;
		// accuracy within which to calculate steady-state value
		double accuracy;
		// compartment containing species to calculate steady-state for
		std::string compartment;
		// monotonicly increasing function
		bool increasing;
		// save calculated model as hdf5 file
		bool save_hdf5;
		// dynamically adjust upper and lower search bounds
		bool adjust_bounds;

		// set a parameter value
		bool setParameter(char *name, char *value);

		// write parameter set to file
		void write(const char *filename);
};

#endif
