// multicompartment gillespie cellular potts class definitions
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef MULTICOMPARTMENTGILLESPIECELLULARPOTTS_H
#define MULTICOMPARTMENTGILLESPIECELLULARPOTTS_H

#include "Psystem.h"
#include <map>

namespace Simulation {

// waiting time multimap types
typedef pair<double, unsigned long> waiting_time_entry;
typedef multimap <double, unsigned long>::iterator waiting_time_iterator;

// gillespie direct method with queue
class MulticompartmentGillespieCellularPotts : public SimulationAlgorithm {
		multimap<double, unsigned long> waiting_times;
		double *waiting_times_hash;
		double tau0global;
		waiting_time_iterator waiting_times_head;
		Lattice *lattice;
		unsigned long gillespie_steps;

	public:
		// constructor
		MulticompartmentGillespieCellularPotts(const unsigned long seed = 0);

		// destructor
		~MulticompartmentGillespieCellularPotts();

		// perform one iteration of algorithm for all compartments
		int execute(void);

		// perform one iteration of algorithm for one compartment
		void execute(unsigned long);

		// initialise algorithm
		int preprocess(void);
};

}

#endif
