// multicompartment gillespie direct method with queue class definitions
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef MULTICOMPARTMENTGILLESPIEQ_H
#define MULTICOMPARTMENTGILLESPIEQ_H

#include "Psystem.h"
#include <map>

namespace Simulation {

// waiting time multimap types
typedef pair<double, unsigned long> waiting_time_entry;
typedef multimap <double, unsigned long>::iterator waiting_time_iterator;

// gillespie direct method with queue
class MulticompartmentGillespieQ : public SimulationAlgorithm {
		multimap<double, unsigned long> waiting_times;
		double *waiting_times_hash;
		waiting_time_iterator waiting_times_head;

	public:
		// constructor
		MulticompartmentGillespieQ(const unsigned long seed = 0);

		// destructor
		~MulticompartmentGillespieQ();

		// perform one iteration of algorithm for all compartments
		int execute(void);

		// perform one iteration of algorithm for one compartment
		void execute(unsigned long);

		// initialise algorithm
		int preprocess(void);
};

}

#endif
