// multicompartment gillespie direct method with queue class definitions
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef MULTICOMPARTMENTGILLESPIEQ2_H
#define MULTICOMPARTMENTGILLESPIEQ2_H

#include "Psystem.h"
#include "ecsb/BHPQ.h"

namespace Simulation {

// gillespie direct method with queue
class MulticompartmentGillespieQ2 : public SimulationAlgorithm {
		BinaryHeapPriorityQueue *waiting_times;
		QueueEntry qe;

	public:
		// constructor
		MulticompartmentGillespieQ2(const unsigned long seed = 0);

		// destructor
		~MulticompartmentGillespieQ2();

		// perform one iteration of algorithm for all compartments
		int execute(void);

		// perform one iteration of algorithm for one compartment
		void execute(unsigned long);

		// initialise algorithm
		int preprocess(void);
};

}

#endif
