// multicompartment gillespie direct method with queue and growth class definitions
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef MULTICOMPARTMENTGILLESPIEQ2G_H
#define MULTICOMPARTMENTGILLESPIEQ2G_H

#include "Psystem.h"
#include "ecsb/BHPQ.h"

namespace Simulation {

// gillespie direct method with queue
class MulticompartmentGillespieQ2G : public SimulationAlgorithm {
		BinaryHeapPriorityQueue *waiting_times;
		QueueEntry qe;
		unsigned long *compartment_reactions;
		double *last_volume_update;

	public:
		// constructor
		MulticompartmentGillespieQ2G(const unsigned long seed = 0);

		// destructor
		~MulticompartmentGillespieQ2G();

		// perform one iteration of algorithm for all compartments
		int execute(void);

		// perform one iteration of algorithm for one compartment
		void execute(unsigned long);

		// initialise algorithm
		int preprocess(void);
};

}

#endif
