// multicompartment gillespie direct method (growth and division with queue)
// class definitions
// copyright 2008, 2009, 2010 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef MULTICOMPARTMENTGILLESPIEQ2GD_H
#define MULTICOMPARTMENTGILLESPIEQ2GD_H

#include "Psystem.h"
#include "ecsb/BHPQ.h"

namespace Simulation {

// gillespie direct method with queue
class MulticompartmentGillespieQ2GD : public SimulationAlgorithm {
		BinaryHeapPriorityQueue *waiting_times;
		QueueEntry qe;
		unsigned long *compartment_reactions;
		unsigned long *compartment_reactions_division;
		double *last_volume_update;
		void rescale(void);

	public:
		// constructor
		MulticompartmentGillespieQ2GD(const unsigned long seed = 0);

		// destructor
		~MulticompartmentGillespieQ2GD();

		// perform one iteration of algorithm for all compartments
		int execute(void);

		// perform one iteration of algorithm for one compartment
		void execute(unsigned long);

		// initialise algorithm
		int preprocess(void);
};

}

#endif
