// mcss2sbml - convert mcss model into compliant sbml
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#if HAVE_CONFIG_H
	#include <config.h>
#endif

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <mcss/mcss.h>

using namespace std;
using namespace Simulation;

int main(int argc, char **argv)
{
	// parse command line
	if(argc != 3) {
		cerr << "mcss2sbml MCSS_PARAMETER_FILE SBML_OUTPUT_FILE\n";
		exit(EXIT_FAILURE);
	}

	// read in parameters
	SimulationParameters parameters;
	parameters.read(argv[1]);

	// create p-system from parameters specified in parameter file
	Psystem psystem(parameters);

	// save model as compliant sbml
	psystem.outputSBML(argv[2]);

	return 0;
}
