// sbml-set-compartment volume - set volume of compartment in sbml file
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#if HAVE_CONFIG_H
	#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <mcss/mcss.h>

using namespace std;
using namespace Simulation;

int main(int argc, char **argv)
{
	char *filename, *compartment, *endptr;
	double value;

	// parse command line
	if(argc == 1)
		fprintf(stderr, "sbml-set-compartment-volume version %s\n", VERSION);
	if(argc != 4) {
		fprintf(stderr, "sbml-set-compartment-volume SBMLFILE " \
				"COMPARTMENT VOLUME\n");
		exit(EXIT_FAILURE);
	}
	if(!(filename = (char *) calloc(strlen(argv[1]) + 1, sizeof(char)))) {
		fprintf(stderr, "error: unable to allocate memory for filename\n");
		exit(EXIT_FAILURE);
	}
	strncpy(filename, argv[1], strlen(argv[1]));
	filename[strlen(argv[1])] = '\0';
	if(!(compartment = (char *) calloc(strlen(argv[2]) + 1, sizeof(char)))) {
		fprintf(stderr, "error: unable to allocate memory for compartment\n");
		exit(EXIT_FAILURE);
	}
	strncpy(compartment, argv[2], strlen(argv[2]));
	compartment[strlen(argv[2])] = '\0';
	errno = 0;
	value = strtod(argv[3], &endptr);
	if(errno != 0 || endptr == argv[3] || *endptr != '\0') {
		fprintf(stderr, "error: unable to convert volume %s to double\n", \
				argv[3]);
		exit(EXIT_FAILURE);
	}

	// set compartment
	sbml_set_compartment_volume(filename, compartment, value);

	// all done
	exit(EXIT_SUCCESS);
}
