// sbml-set-event-assignment - set variable in sbml event
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#if HAVE_CONFIG_H
	#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <mcss/mcss.h>

using namespace std;
using namespace Simulation;

int main(int argc, char **argv)
{
	char *filename, *variable, *event, *endptr;
	long double value;

	// parse command line
	if(argc == 1)
		fprintf(stderr, "sbml-set-event-assignment version %s\n", VERSION);
	if(argc != 5) {
		fprintf(stderr, "sbml-set-event-assignment SBMLFILE VARIABLE " \
				"EVENT VALUE\n");
		exit(EXIT_FAILURE);
	}
	if(!(filename = (char *) calloc(strlen(argv[1]) + 1, sizeof(char)))) {
		fprintf(stderr, "error: unable to allocate memory for filename\n");
		exit(EXIT_FAILURE);
	}
	strncpy(filename, argv[1], strlen(argv[1]));
	filename[strlen(argv[1])] = '\0';
	if(!(variable = (char *) calloc(strlen(argv[2]) + 1, sizeof(char)))) {
		fprintf(stderr, "error: unable to allocate memory for variable\n");
		exit(EXIT_FAILURE);
	}
	strncpy(variable, argv[2], strlen(argv[2]));
	variable[strlen(argv[2])] = '\0';
	if(!(event = (char *) calloc(strlen(argv[3]) + 1, sizeof(char)))) {
		fprintf(stderr, "error: unable to allocate memory for event\n");
		exit(EXIT_FAILURE);
	}
	strncpy(event, argv[3], strlen(argv[3]));
	event[strlen(argv[3])] = '\0';
	errno = 0;
	value = strtold(argv[4], &endptr);
	if(errno != 0 || endptr == argv[4] || *endptr != '\0') {
		fprintf(stderr, "error: unable to convert value %s to double\n", \
				argv[4]);
		exit(EXIT_FAILURE);
	}

	// set event assignment
	sbml_set_event_assignment(filename, variable, event, value);

	// all done
	exit(EXIT_SUCCESS);
}
