// sbml-set-initial-amount - set initial amount of species in sbml file
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#if HAVE_CONFIG_H
	#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <mcss/mcss.h>

using namespace std;
using namespace Simulation;

int main(int argc, char **argv)
{
	char *filename, *species, *compartment, *endptr;
	unsigned long value;

	// parse command line
	if(argc == 1)
		fprintf(stderr, "sbml-set-initial-amount version %s\n", VERSION);
	if(argc != 5) {
		fprintf(stderr, "sbml-set-initial-amount SBMLFILE SPECIES " \
				"COMPARTMENT AMOUNT\n");
		exit(EXIT_FAILURE);
	}
	if(!(filename = (char *) calloc(strlen(argv[1]) + 1, sizeof(char)))) {
		fprintf(stderr, "error: unable to allocate memory for filename\n");
		exit(EXIT_FAILURE);
	}
	strncpy(filename, argv[1], strlen(argv[1]));
	filename[strlen(argv[1])] = '\0';
	if(!(species = (char *) calloc(strlen(argv[2]) + 1, sizeof(char)))) {
		fprintf(stderr, "error: unable to allocate memory for species\n");
		exit(EXIT_FAILURE);
	}
	strncpy(species, argv[2], strlen(argv[2]));
	species[strlen(argv[2])] = '\0';
	if(!(compartment = (char *) calloc(strlen(argv[3]) + 1, sizeof(char)))) {
		fprintf(stderr, "error: unable to allocate memory for compartment\n");
		exit(EXIT_FAILURE);
	}
	strncpy(compartment, argv[3], strlen(argv[3]));
	compartment[strlen(argv[3])] = '\0';
	value = strtoul(argv[4], &endptr, 10);
	if((errno == ERANGE && value == ULONG_MAX) || (errno != 0 && value == 0) \
			|| endptr == argv[4] || *endptr != '\0') {
		fprintf(stderr, "error: unable to convert value %s to unsigned " \
				"integer\n", argv[4]);
		exit(EXIT_FAILURE);
	}

	// set initial amount
	sbml_set_initial_amount(filename, species, compartment, (unsigned int) value);

	// all done
	exit(EXIT_SUCCESS);
}
