// sbml-set-parameter - set parameter in sbml file
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#if HAVE_CONFIG_H
	#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <mcss/mcss.h>

using namespace std;
using namespace Simulation;

int main(int argc, char **argv)
{
	char *filename, *parameter, *endptr;
	double value;

	// parse command line
	if(argc == 1)
		fprintf(stderr, "sbml-set-parameter version %s\n", VERSION);
	if(argc != 4) {
		fprintf(stderr, \
				"sbml-set-parameter SBMLFILE PARAMETER VALUE\n");
		exit(EXIT_FAILURE);
	}
	if(!(filename = (char *) calloc(strlen(argv[1]) + 1, sizeof(char)))) {
		fprintf(stderr, "error: unable to allocate memory for filename\n");
		exit(EXIT_FAILURE);
	}
	strncpy(filename, argv[1], strlen(argv[1]));
	filename[strlen(argv[1])] = '\0';
	if(!(parameter = (char *) calloc(strlen(argv[2]) + 1, sizeof(char)))) {
		fprintf(stderr, "error: unable to allocate memory for parameter\n");
		exit(EXIT_FAILURE);
	}
	strncpy(parameter, argv[2], strlen(argv[2]));
	parameter[strlen(argv[2])] = '\0';
	errno = 0;
	value = strtod(argv[3], &endptr);
	if(errno != 0 || endptr == argv[3] || *endptr != '\0') {
		fprintf(stderr, "error: unable to convert value %s to double\n", \
				argv[3]);
		exit(EXIT_FAILURE);
	}

	// set reaction constant
	sbml_set_parameter(filename, parameter, value);

	// all done
	exit(EXIT_SUCCESS);
}
