#!/bin/sh
# tissue p-system simulator
# discrete stochastic models test suite tests
# copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
# released under GNU GPL version 3

# number of runs to run tests for - recommended 10,000
runs=$1

# one variable models
models1v="dsmts-001-02 dsmts-001-03 dsmts-001-04 dsmts-001-05"

# two variable models
models2v="dsmts-001-07"

# simulation algorithms
simalgs="dm dmq dmq2"

# run tests for one variable models
for model in $models1v
do
	# for each simulation algorithm
	for simalg in $simalgs
	do
		echo "running test for model=$model simalg=$simalg..."
		./run-test.sh $model $runs $simalg
	done
done

# run tests for two variable models
for model in $models2v
do
	# for each simulation algorithm
	for simalg in $simalgs
	do
		echo "running test for model=$model simalg=$simalg..."
		./run-test.two-vars.sh $model $runs $simalg
	done
done
